package panel;

import org.junit.jupiter.api.Test;
import org.mybatis.spring.boot.test.autoconfigure.AutoConfigureMybatis;
import org.mybatis.spring.boot.test.autoconfigure.MybatisTest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.jdbc.AutoConfigureTestDatabase;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import rition.backend.RitionBackendMain;
import rition.common.data.dao.mapper.MetricRecordMapper;

import java.time.Instant;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@MybatisTest
@ContextConfiguration(classes = RitionBackendMain.class)
@AutoConfigureTestDatabase(replace = AutoConfigureTestDatabase.Replace.NONE)
public class MetricServiceTest {
    @Autowired
    MetricRecordMapper metricRecordMapper;

    @Test
    public void testGetMetricRecord() {
        List<String> metricItems = new ArrayList<>();
        metricItems.add("node_network_receive_packets_total");
        metricItems.add("node_sockstat_TCP_tw");
        var result = metricRecordMapper.getMetricDataGroupByHour(
                "7273a1ea-0089-4674-b606-b1b8d809d866",
                metricItems,
                Instant.parse("2024-04-17T14:00:00.00Z"),
                Instant.parse("2024-04-17T16:00:00.00Z")
        );

        System.out.println(Arrays.toString(result.toArray()));
    }
}
